<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<%@page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<%@ taglib uri="http://www.sas.com/taglib/sas-flex" prefix="sas-flex" %>
<%@page import="com.sas.web.keys.CommonKeys"%>
<%@page import="java.util.Properties"%>
<%@page import="com.sas.svcs.config.client.ConfigurationServiceInterface"%>
<%@page import="org.springframework.web.context.support.WebApplicationContextUtils"%>
<%@page import="org.springframework.web.context.WebApplicationContext"%>

<html>
	<head>
		<title>SAS High-Performance Risk</title>
	</head>
	<body scroll="no">

    <script language="JavaScript" type="text/javascript">

          /*  Kick off synchronous Logoff in onbeforeunload.
              This will cleanup any mess left on server like SAS sessoins.  
                     
              For this to work we cannot bring up the "leave page or stay message"
              because the logoff would happen independent of that message so if
              user said "stay" it would leave them in bad state.
                    
              You can't control the message from this beforeunload because Flex application
              tag also has it's own onbeforeload which is handling the message.  Turn if off
              via sas-flex:application property

          */

/* Defect S0912819 - Commenting all this out for now. It works well for cleaning up all the sas connections
                     in play for this session.  But since browsers all share sessions across tabs nowadays
                     it means that cleanup triggered by leaving HPRisk in one tab will hose any instances
                     of HPRisk in another tab that are sharing the same session.
                     
                     
*/                     
//          if(window.attachEvent!=null) // IE
//          {
//              window.attachEvent('onbeforeunload', beforeUnloadHandler);
//          }
//          else
//          {
//              window.addEventListener('beforeunload', beforeUnloadHandler, true);
//          }
//
//          function beforeUnloadHandler(event)
//          {
//              var request = new XMLHttpRequest();
//              // For shipping usage this should just be Logoff.  For development
//              // playpens which aren't in root context it should be /SASHighPerformanceRisk/Logoff
////                    request.open('GET', '/SASHighPerformanceRisk/Logoff', false);
//
//              // TODO!!!!!  Should go to custom HPRisk servlet,rather than logoff, which just cleans
//              // up sas connections like the sessionDestroyed code in HPRiskBlazeDSHelper does on session
//              // invalidation.
//              request.open('GET', 'Logoff', false);
//              request.send(null);
//          }
                
    </script> 
			
	<%
		String logoff = 
		java.net.URLEncoder.encode(request.getContextPath() + "/Logoff?&locale=" + request.getLocale(),"UTF-8");

        String startupExplorationEntityKey = request.getParameter(CommonKeys.PFS_REQUEST_ENTITYKEY);
        String startupExplorationAction = request.getParameter(CommonKeys.PFS_REQUEST_ACTION);
        String debugOption = request.getParameter("debug");
        
		//System.out.println("URL = " + request.getRequestURL().toString());
		//System.out.println("QueryString = " + request.getQueryString());

		// Application Switcher integration
        String launchedFromAppSwitcher = request.getParameter("launchedFromAppSwitcher");
		boolean isAppSwitcherEnabled = ((launchedFromAppSwitcher!=null) && (launchedFromAppSwitcher.toLowerCase().equals("true"))) ;
		boolean browserUnloadWarningEnabled = !isAppSwitcherEnabled;

		//System.out.println("launchedFromAppSwitcher = " + launchedFromAppSwitcher);
		//System.out.println("isAppSwitcherEnabled = " + isAppSwitcherEnabled);

		String dataItemLabels = null;
		WebApplicationContext context = WebApplicationContextUtils.getWebApplicationContext(session.getServletContext());
		ConfigurationServiceInterface configurationService = (ConfigurationServiceInterface) context.getBean("svcs.configurationService");
		if (configurationService != null)
		{
			String appName = session.getServletContext().getInitParameter(CommonKeys.APPLICATION_NAME_PARAM);
			if (appName != null)
			{
				Properties appSettings = configurationService.getSettings(appName);
				if (appSettings != null)
				{
					dataItemLabels = appSettings.getProperty("hprisk.dataItemLabels");
				}
			}
		}
	%>
	
		<!-- Application Switcher integration -->
		<sas-flex:appSwitcher appId="HPRiskLogon" />

		
		<!-- HPRisk application -->
		<sas-flex:application swf="HPRisk.swf" backLinksEnabled="true" enhancedContextMenuEnabled="true" browserUnloadWarningEnabled="<%=browserUnloadWarningEnabled%>">
			<sas-flex:flashvar name="logoffURL" value="<%=logoff%>"/>
			<sas-flex:flashvar name="dataItemLabels" value="<%=dataItemLabels%>"/>
            <% if (startupExplorationEntityKey!=null){ %> 
                 <sas-flex:flashvar name="explorationEntityKey" value="<%=startupExplorationEntityKey%>" />
            <% } %>
            <% if (startupExplorationAction!=null){ %> 
                 <sas-flex:flashvar name="explorationAction" value="<%=startupExplorationAction%>" />
            <% } %>
            <% if (debugOption!=null){ %> 
                 <sas-flex:flashvar name="debug" value="<%=debugOption%>" />
            <% } %>
		</sas-flex:application> 
	</body>
</html> 

